//
//  920MHz LoRa/FSK RF module ES920LR3 
//  via Software Serial
//
//  MaiaR create
//

#include "LoRa.h"

#include <SoftwareSerial.h>
SoftwareSerial SwSerial(2, 3); // RX, TX

int ResetPin = 8;

void LoRaReset(){
  pinMode(ResetPin, OUTPUT); // NRST "L"
  digitalWrite(ResetPin, LOW);
  delay(10);
  pinMode(ResetPin, INPUT);  // NRST open
}

void LoRaConfigMode(){
  Serial.begin(115200);
  SwSerial.begin(115200);
  while(1){
    LoRaReset();
    String rx = SwSerial.readString();
    Serial.println(rx);
    if (rx.indexOf("Select Mode") >= 0) break;
    LoRaCommand("config");
  }
}

int LoRaCommand(String s){
  SwSerial.print(s + "\r\n");
  SwSerial.flush();
  Serial.println(s);
  String rx = SwSerial.readString();
  Serial.print(rx);
  return (rx.indexOf("OK"));
}


int LoRaInit(){
  LoRaConfigMode();
  SwSerial.print("2\r\n");   // processor mode
  SwSerial.print("r 4\r\n"); // baudrate 57600
  SwSerial.begin(57600);
  if (LoRaCommand("c 12"  ) < 0) return(-1); // spread factor
  if (LoRaCommand("d 3"   ) < 0) return(-1); // channel
  if (LoRaCommand("e 2345") < 0) return(-1); // PAN ID
  if (LoRaCommand("f 1"   ) < 0) return(-1); // own ID
  if (LoRaCommand("g ffff") < 0) return(-1); // broadcast
  if (LoRaCommand("z"     ) < 0) return(-1); // start
  return(0);
}
